# auto-generated tests from julia-repl docstrings
using Test, PermGroups
function mytest(file::String,cmd::String,man::String)
  println(file," ",cmd)
  exec=repr(MIME("text/plain"),eval(Meta.parse(cmd)),context=:limit=>true)
  if endswith(cmd,";") exec="nothing" 
  else exec=replace(exec,r"\s*$"m=>"")
       exec=replace(exec,r"\s*$"s=>"")
       exec=replace(exec,r"^\s*"=>"")
  end
  if exec==man return true end
  i=1
  while i<=lastindex(exec) && i<=lastindex(man) && exec[i]==man[i]
    i=nextind(exec,i)
  end
  print("exec=$(repr(exec[i:end]))\nmanl=$(repr(man[i:end]))\n")
  return false
end
@testset verbose = true "PermGroups" begin
@testset "Groups.jl" begin
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3))","Group((1,2),(1,2,3))")
@test mytest("Groups.jl","gens(G)","2-element Vector{Perm{Int16}}:\n (1,2)\n (1,2,3)")
@test mytest("Groups.jl","ngens(G)","2")
@test mytest("Groups.jl","minimal_words(G)","OrderedDict{Perm{Int16}, Vector{Int64}} with 6 entries:\n  ()      => []\n  (1,2)   => [1]\n  (1,2,3) => [2]\n  (1,3)   => [1, 2]\n  (2,3)   => [2, 1]\n  (1,3,2) => [2, 2]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3))","Group((1,2),(1,2,3))")
@test mytest("Groups.jl","G(2,1,-2)","(1,3)")
@test mytest("Groups.jl","orbit([Perm(1,2),Perm(2,3)],1)","3-element Vector{Int64}:\n 1\n 2\n 3")
@test mytest("Groups.jl","orbit([Perm(1,2),Perm(2,3)],[1,3],ontuples)","6-element Vector{Vector{Int64}}:\n [1, 3]\n [2, 3]\n [1, 2]\n [3, 2]\n [2, 1]\n [3, 1]")
@test mytest("Groups.jl","orbit([Perm(1,2),Perm(2,3)],[1,3],(v,g)->sort(v.^g))","3-element Vector{Vector{Int64}}:\n [1, 3]\n [2, 3]\n [1, 2]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(2,3));","nothing")
@test mytest("Groups.jl","transversal(G,1)","OrderedDict{Int64, Perm{Int16}} with 3 entries:\n  1 => ()\n  2 => (1,2)\n  3 => (1,3,2)")
@test mytest("Groups.jl","transversal(G,(1,2),ontuples)","OrderedDict{Tuple{Int64, Int64}, Perm{Int16}} with 6 entries:\n  (1, 2) => ()\n  (2, 1) => (1,2)\n  (1, 3) => (2,3)\n  (3, 1) => (1,3,2)\n  (2, 3) => (1,2,3)\n  (3, 2) => (1,3)")
@test mytest("Groups.jl","words_transversal([Perm(1,2),Perm(2,3)],1)","OrderedDict{Int64, Vector{Int64}} with 3 entries:\n  1 => []\n  2 => [1]\n  3 => [1, 2]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(2,3));","nothing")
@test mytest("Groups.jl","orbits(G,1:4)","2-element Vector{Vector{Int64}}:\n [1, 2, 3]\n [4]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3));","nothing")
@test mytest("Groups.jl","centralizer(G,1)","Group((2,3))")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3))","Group((1,2),(1,2,3))")
@test mytest("Groups.jl","centralizer(G,Group(Perm(1,2)))","Group((1,2))")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3,4))","Group((1,2),(1,2,3,4))")
@test mytest("Groups.jl","stabilizer(G,[1,2],onsets)","Group((3,4),(1,2))")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(3,4),Perm(1,3)*Perm(2,4))","Group((1,2),(3,4),(1,3)(2,4))")
@test mytest("Groups.jl","center(G)","Group((1,2)(3,4))")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3));","nothing")
@test mytest("Groups.jl","minimal_words(G)","OrderedDict{Perm{Int16}, Vector{Int64}} with 6 entries:\n  ()      => []\n  (1,2)   => [1]\n  (1,2,3) => [2]\n  (1,3)   => [1, 2]\n  (2,3)   => [2, 1]\n  (1,3,2) => [2, 2]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(2,3));","nothing")
@test mytest("Groups.jl","minimal_words(G,Perm(1,3))","2-element Vector{Vector{Int64}}:\n [1, 2, 1]\n [2, 1, 2]")
@test mytest("Groups.jl","G=Group(Perm(1,2),Perm(1,2,3));","nothing")
@test mytest("Groups.jl","words(G)","OrderedDict{Perm{Int16}, Vector{Int64}} with 6 entries:\n  ()      => []\n  (1,2)   => [1]\n  (1,2,3) => [2]\n  (1,3)   => [1, 2]\n  (2,3)   => [2, 1]\n  (1,3,2) => [1, 2, 1]")
@test mytest("Groups.jl","g=Group(perm\"(1,2,3)(6,7)\",perm\"(3,4,5)(7,8)\")","Group((1,2,3)(6,7),(3,4,5)(7,8))")
@test mytest("Groups.jl","transporting_elt(g,1,5)","(1,5,4,3,2)")
@test mytest("Groups.jl","transporting_elt(g,1,6)","nothing")
@test mytest("Groups.jl","transporting_elt(g,[1,2,3,4],[2,3,4,5],(s,g)->sort(s.^g))","(1,2,3,4,5)(6,7,8)")
@test mytest("Groups.jl","transporting_elt(g,[1,2,3,4],[3,4,5,2],(s,g)->s.^g)","nothing")
@test mytest("Groups.jl","S=Group(Perm(1,2),Perm(2,3))","Group((1,2),(2,3))")
@test mytest("Groups.jl","T=Group(Perm(1,2))","Group((1,2))")
@test mytest("Groups.jl","h=Hom(S,T,[T(1),T(1)])","Hom(Group((1,2),(2,3))→ Group((1,2));[(1,2), (2,3)]↦ [(1,2), (1,2)]")
@test mytest("Groups.jl","h(S(1,2))","()")
@test mytest("Groups.jl","G=Group([[-1 -1;1 0]])","Group([[-1 -1; 1 0]])")
@test mytest("Groups.jl","elements(G)","3-element Vector{Matrix{Int64}}:\n [1 0; 0 1]\n [-1 -1; 1 0]\n [0 1; -1 -1]")
end
@testset "PermGroups.jl" begin
@test mytest("PermGroups.jl","G=Group([Perm(i,i+1) for i in 1:2])","Group((1,2),(2,3))")
@test mytest("PermGroups.jl","collect(G)","6-element Vector{Perm{Int16}}:\n ()\n (1,2)\n (1,3,2)\n (2,3)\n (1,2,3)\n (1,3)")
@test mytest("PermGroups.jl","last_moved(G)","3")
@test mytest("PermGroups.jl","orbits(G)","1-element Vector{Vector{Int16}}:\n [1, 2, 3]")
@test mytest("PermGroups.jl","Perm(1,2) in G","true")
@test mytest("PermGroups.jl","Perm(1,2,4) in G","false")
@test mytest("PermGroups.jl","get_stabchain(G)","b:1 c:Group((1,2),(2,3))\n  δ:1=>(),2=>(1,2),3=>(1,3,2)\nb:2 c:Group((2,3))\n  δ:2=>(),3=>(2,3)")
@test mytest("PermGroups.jl","W=Group(Perm(1,2),Perm(2,3),Perm(4,5),Perm(5,6))","Group((1,2),(2,3),(4,5),(5,6))")
@test mytest("PermGroups.jl","on_classes(W,Perm(1,4,2,5,3,6))","(2,4)(3,7)(6,8)")
@test mytest("PermGroups.jl","stab_onmats((1:30)'.*(1:30).%15)","Group((1,16),(4,19),(11,26),(14,29),(2,17),(7,22),(8,23),(13,28),(6,21),(9,24),(1,4)(2,8)(3,12)(6,9)(7,13)(11,14)(16,19)(17,23)(18,27)(21,24)(22,28)(26,29),(3,18),(12,27),(1,11)(2,7)(4,14)(5,10)(8,13)(16,26)(17,22)(19,29)(20,25)(23,28),(5,20),(10,25),(15,30))")
@test mytest("PermGroups.jl","Perm([0 1 0;0 0 1;1 0 0],[1 0 0;0 1 0;0 0 1];dims=1)","(1,3,2)")
@test mytest("PermGroups.jl","Perm([0 1 0;0 0 1;1 0 0],[1 0 0;0 1 0;0 0 1];dims=2)","(1,2,3)")
@test mytest("PermGroups.jl","n=(1:30)'.*(1:30).%15;","nothing")
@test mytest("PermGroups.jl","m=onmats(n,Perm(1,5,2,8,12,4,7)*Perm(3,9,11,6));","nothing")
@test mytest("PermGroups.jl","Perm(m,n,dims=(1,2))","(1,5,2,8,12,4,7)(3,9,11,6)")
end
@testset "Perms.jl" begin
@test mytest("Perms.jl","a=Perm(1,2,3)","(1,2,3)")
@test mytest("Perms.jl","perm(a)","3-element Vector{Int16}:\n 2\n 3\n 1")
@test mytest("Perms.jl","a==Perm(perm(a))","true")
@test mytest("Perms.jl","b=Perm(1,2,3,4)","(1,2,3,4)")
@test mytest("Perms.jl","a*b","(1,3,2,4)")
@test mytest("Perms.jl","inv(a)","(1,3,2)")
@test mytest("Perms.jl","a/b","(3,4)")
@test mytest("Perms.jl","a\\b","(1,4)")
@test mytest("Perms.jl","a^b","(2,3,4)")
@test mytest("Perms.jl","b^2","(1,3)(2,4)")
@test mytest("Perms.jl","1^a","2")
@test mytest("Perms.jl","one(a)","()")
@test mytest("Perms.jl","sign(a)","1")
@test mytest("Perms.jl","order(a)","3")
@test mytest("Perms.jl","last_moved(a)","3")
@test mytest("Perms.jl","first_moved(a)","1")
@test mytest("Perms.jl","Perm{Int8}(a)","Perm{Int8}: (1,2,3)")
@test mytest("Perms.jl","Matrix(b)","4×4 Matrix{Bool}:\n 0  1  0  0\n 0  0  1  0\n 0  0  0  1\n 1  0  0  0")
@test mytest("Perms.jl","Perms.Perm_(UInt8[1,3,2,4])","Perm{UInt8}: (2,3)")
@test mytest("Perms.jl","perm(Perm(2,3;degree=4))","4-element Vector{Int16}:\n 1\n 3\n 2\n 4")
@test mytest("Perms.jl","Matrix(Perm(2,3,4),5)","5×5 Matrix{Bool}:\n 1  0  0  0  0\n 0  0  1  0  0\n 0  0  0  1  0\n 0  1  0  0  0\n 0  0  0  0  1")
@test mytest("Perms.jl","Perm([0 1 0;0 0 1;1 0 0])","(1,2,3)")
@test mytest("Perms.jl","invpermute([5,4,6],Perm(1,2,3))","3-element Vector{Int64}:\n 6\n 5\n 4")
@test mytest("Perms.jl","m=reshape(1:9,3,3)","3×3 reshape(::UnitRange{Int64}, 3, 3) with eltype Int64:\n 1  4  7\n 2  5  8\n 3  6  9")
@test mytest("Perms.jl","invpermute(m,Perm(1,2),Perm(2,3))","3×3 Matrix{Int64}:\n 2  8  5\n 1  7  4\n 3  9  6")
@test mytest("Perms.jl","m=reshape(1:9,3,3)","3×3 reshape(::UnitRange{Int64}, 3, 3) with eltype Int64:\n 1  4  7\n 2  5  8\n 3  6  9")
@test mytest("Perms.jl","p=Perm(1,2,3)","(1,2,3)")
@test mytest("Perms.jl","invpermute(m,p)","3×3 Matrix{Int64}:\n 3  6  9\n 1  4  7\n 2  5  8")
@test mytest("Perms.jl","invpermute(m,p;dims=2)","3×3 Matrix{Int64}:\n 7  1  4\n 8  2  5\n 9  3  6")
@test mytest("Perms.jl","invpermute(m,p;dims=(1,2))","3×3 Matrix{Int64}:\n 9  3  6\n 7  1  4\n 8  2  5")
@test mytest("Perms.jl","orbits(Perm(1,2)*Perm(4,5),1:5)","3-element Vector{Vector{Int64}}:\n [1, 2]\n [3]\n [4, 5]")
@test mytest("Perms.jl","cycles(Perm(1,2)*Perm(4,5))","2-element Vector{Vector{Int16}}:\n [1, 2]\n [4, 5]")
@test mytest("Perms.jl","cycletype(Perm(1,2)*Perm(4,5))","2-element Vector{Int64}:\n 2\n 2")
@test mytest("Perms.jl","cycletype(Perm(1,2)*Perm(4,5),1:5)","3-element Vector{Int64}:\n 2\n 2\n 1")
@test mytest("Perms.jl","cycletype(Perm(1,2)*Perm(4,5),1:6)","4-element Vector{Int64}:\n 2\n 2\n 1\n 1")
@test mytest("Perms.jl","restricted(Perm(1,2)*Perm(3,4),3:4)","(3,4)")
@test mytest("Perms.jl","p=mappingPerm([6,7,5])","(5,6,7)")
@test mytest("Perms.jl","(5:7).^p","3-element Vector{Int64}:\n 6\n 7\n 5")
@test mytest("Perms.jl","mappingPerm([1,2,5,3],[2,3,4,6])","(1,2,3,6,5,4)")
@test mytest("Perms.jl","Perm([0,2,4],[4,0,2])","(1,3,2)")
@test mytest("Perms.jl","a=[1 1 1 -1 -1; 2 0 -2 0 0; 1 -1 1 -1 1; 1 1 1 1 1; 1 -1 1 1 -1]","5×5 Matrix{Int64}:\n 1   1   1  -1  -1\n 2   0  -2   0   0\n 1  -1   1  -1   1\n 1   1   1   1   1\n 1  -1   1   1  -1")
@test mytest("Perms.jl","b=[1 -1 -1 1 1; 1 1 -1 -1 1; 1 -1 1 -1 1; 2 0 0 0 -2; 1 1 1 1 1]","5×5 Matrix{Int64}:\n 1  -1  -1   1   1\n 1   1  -1  -1   1\n 1  -1   1  -1   1\n 2   0   0   0  -2\n 1   1   1   1   1")
@test mytest("Perms.jl","p1,p2=Perm_rowcol(a,b)","((1,3,5,4,2), (3,4,5))")
@test mytest("Perms.jl","invpermute(b,p1,p2)==a","true")
end
end
